<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="姓名" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入姓名"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="角色" prop="roleId">
        <el-select v-model="queryParams.roleId" placeholder="请选择角色">
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="性别" prop="sex">
        <el-select v-model="queryParams.sex" placeholder="请选择性别">
          <el-option v-for="dict in dict.type.sys_user_sex" :key="dict.value" :label="dict.label"
                     :value="dict.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['dataCenter:member:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['dataCenter:member:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['dataCenter:member:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="teamMemberList" :height="tableHeight" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" label="序号" :index="indexMethod" width="80" />
      <el-table-column label="姓名" align="center" prop="userName" />
      <el-table-column label="性别" align="center" prop="sex" >
        <template slot-scope="scope">
          <span>{{ dict.type.sys_user_sex.find(opt => opt.value === scope.row.sex).label }}</span>
        </template>
      </el-table-column>
      <el-table-column label="角色" align="center" prop="roleId" >
        <template slot-scope="scope">
          <span>{{ options
            .filter(opt => scope.row.roleId.split(",").includes(opt.value))
            .map(opt => opt.label)
            .join(", ") }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['dataCenter:member:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['dataCenter:member:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改标注人员和角色关联对话框 -->
    <el-dialog title="添加" :visible.sync="addOpen" width="800px"  append-to-body @close="cancel">
      <el-form ref="addForm" :model="addForm" :rules="addRules" label-width="80px">
      <el-form-item label="角色" prop="roleIds">
        <el-select v-model="addForm.roleIds" multiple   style="width: 30%;" placeholder="请选择">
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
        <el-form-item  prop="selectedData">
          <el-transfer
            :key="transferKey"
            ref="transfer"
            style="text-align: left; display: inline-block"
            v-model="addForm.selectedData"
            filterable
            :render-content="renderFunc"
            :titles="['待选择', '已选择']"
            :format="{
        noChecked: '${total}',
        hasChecked: '${checked}/${total}'
      }"
            :data="userList">
          </el-transfer>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="addTeamMember">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 修改对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules">
        <el-form-item label="姓名" prop="userName">
          <el-input v-model="form.userName" maxlength="20" readonly placeholder="请输入姓名" />
        </el-form-item>
        <el-form-item label="角色" prop="roleIds">
          <el-select v-model="form.roleIds" @change="$forceUpdate()" multiple style="width: 100%" placeholder="请选择角色">
            <el-option
              v-for="item in options"
              :key="item.value"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="updateTeamMember">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { list, getTeamMember, delTeamMember, addTeamMember, updateTeamMember,buildDeptTreeWithUsers} from "@/api/dataCenter/teamMember";

export default {
  dicts: ['sys_user_sex'],
  name: "TeamMember",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 标注人员和角色关联表格数据
      teamMemberList: [],
      //用户信息
      userList:[],
      tableHeight: 0,
      //选择的用户
      selectUser:[],
      // 弹出层标题
      title: "",
      transferKey: 0, // 动态 key 用于刷新组件
      // 是否显示弹出层
      addOpen:false,
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName:null,
        roleId:'',
        sex:''
      },
      // 表单参数
      form: {
        roleIds:[]
      },
      addForm:{
        roleIds:[],
        selectedData:[]
      },
      addRules:{
        roleIds: [
          { required: true, message: '请选择角色', trigger: 'blur' },
          { type: 'array', min: 1, message: '请选择至少一个角色', trigger: 'blur' }
        ],
        selectedData: [
          { required: true, message: '请选择人员', trigger: 'blur' },
        ],
      },
      options: [{
        value: '0',
        label: '标注'
      }, {
        value: '1',
        label: '审核'
      }],
      // 表单校验
      rules: {
        roleIds: [
          { required: true, message: '请选择角色', trigger: 'blur' },
          { type: 'array', min: 1, message: '请选择至少一个角色', trigger: 'blur' }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.buildDeptTreeWithUsers();
    // 初始化表格高度
    this.updateTableHeight();
    // 监听窗口大小变化
    window.addEventListener("resize", this.updateTableHeight);
  },
  methods: {
    indexMethod(index){
      console.log(index);
      return (this.queryParams.pageNum - 1) * this.queryParams.pageSize + index + 1;
    },
    updateTableHeight() {
      // 设置表格高度为窗口高度减去其他元素高度
      const headerHeight = 200; // 头部高度，可以调整
      const footerHeight = 80; // 底部高度，可以调整
      this.tableHeight = window.innerHeight - headerHeight - footerHeight;
    },
    renderFunc(h, option) {
      return <span>{option.label }</span>;
    },
    transformTreeData(data) {
      return data.map(node => {
          return {
            key: node.userId,            // 将 id 改为 key
            label: node.nickName,       // 将 nickName 改为 label
          };
      });

    },
    /** 查询标注人员和角色关联列表 */
    getList() {
      this.loading = true;
      list(this.queryParams).then(response => {
        this.teamMemberList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    buildDeptTreeWithUsers(){
      buildDeptTreeWithUsers(this.queryParams).then(response => {
        this.userList = this.transformTreeData(response.data);
      })
    },
    // 取消按钮
    cancel() {
      this.transferKey += 1; // 更新 key 强制刷新 el-transfer
      this.open = false;
      this.addOpen = false;
      this.reset();
    },
    addTeamMember(){
      this.$refs["addForm"].validate(valid => {
        if (valid) {
          this.addForm.roleId = this.addForm.roleIds.join(",")
          addTeamMember(this.addForm).then(response => {
            this.$modal.msgSuccess("新增成功");
            this.addOpen = false;
            this.transferKey += 1; // 更新 key 强制刷新 el-transfer
            this.getList();
          });
        }
      })

    },
    // 表单重置
    reset() {
      this.form = {
        memberId: null,
        roleId: null,
        delFlag: null,
        createBy: null,
        updateBy: null,
        updateTime: null,
        createTime: null
      };
      this.addForm={
        roleId:null,
        selectedData:[],
      }
      this.resetForm("form");
      this.resetForm("addForm");

    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.memberId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.addOpen = true;
      this.buildDeptTreeWithUsers();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const memberId = row.memberId || this.ids
      getTeamMember(memberId).then(response => {
        this.form = response.data;
        this.form.roleIds = this.form.roleId.split(",").map(role => role.trim()); // 确保去除空格
        console.log(this.form);
        this.open = true;
        this.title = "修改";
      });
    },
    /** 提交按钮 */
    updateTeamMember() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.roleId = this.form.roleIds.join(",")
            updateTeamMember(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const memberIds = row.memberId || this.ids;
      this.$modal.confirm('是否确认删除数据项？').then(function() {
        return delTeamMember(memberIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/member/export', {
        ...this.queryParams
      }, `member_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style scoped>
.custom-tree-transfer {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: flex-start;
  flex-direction: row;
  justify-content: center;
}
</style>
